"use strict";
var __create = Object.create;
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __getProtoOf = Object.getPrototypeOf;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toESM = (mod, isNodeMode, target) => (target = mod != null ? __create(__getProtoOf(mod)) : {}, __copyProps(
  // If the importer is in node compatibility mode or this is not an ESM
  // file that has been converted to a CommonJS file using a Babel-
  // compatible transform (i.e. "__esModule" has not been set), then set
  // "default" to the CommonJS "module.exports" for node compatibility.
  isNodeMode || !mod || !mod.__esModule ? __defProp(target, "default", { value: mod, enumerable: true }) : target,
  mod
));
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);
var DSTruncatedTooltipText_exports = {};
__export(DSTruncatedTooltipText_exports, {
  DSTruncatedTooltipText: () => DSTruncatedTooltipText,
  TruncatedTooltipTextWithSchema: () => TruncatedTooltipTextWithSchema,
  default: () => DSTruncatedTooltipText_default
});
module.exports = __toCommonJS(DSTruncatedTooltipText_exports);
var React = __toESM(require("react"));
var import_jsx_runtime = require("react/jsx-runtime");
var import_react = require("react");
var import_ds_props_helpers = require("@elliemae/ds-props-helpers");
var import_ds_system = require("@elliemae/ds-system");
var import_ds_popper = require("@elliemae/ds-popper");
var import_TooltipTextProvider = require("./TooltipTextProvider.js");
const isEllipsisActive = ({ offsetWidth, scrollWidth }) => offsetWidth < scrollWidth;
const Text = import_ds_system.styled.span`
  text-overflow: ellipsis;
  white-space: nowrap;
  overflow: hidden;
  display: inline-block;
  max-width: 100%;
`;
const DSTruncatedTooltipText = ({
  containerProps = {},
  value = "",
  zIndex = 3e3,
  // https://jira.elliemae.io/browse/PUI-1755 https://jira.elliemae.io/browse/PUI-8732
  ...otherTextProps
}) => {
  const tooltipContext = (0, import_react.useContext)(import_TooltipTextProvider.TruncatedTooltipContext);
  (0, import_react.useEffect)(() => {
    if (zIndex && tooltipContext) tooltipContext.setZIndex(zIndex);
  }, [zIndex]);
  if (!tooltipContext) return value;
  const { showTooltip, hideTooltip } = tooltipContext;
  const handleMouseEnter = (e) => {
    const { target } = e;
    if (target && isEllipsisActive(target, target.getBoundingClientRect())) {
      showTooltip(
        {
          value,
          reference: target
        },
        e
      );
    }
  };
  const handleMouseLeave = (e) => {
    hideTooltip({ reference: e.target });
  };
  const handlers = showTooltip ? { onMouseEnter: handleMouseEnter, onMouseLeave: handleMouseLeave } : {};
  return /* @__PURE__ */ (0, import_jsx_runtime.jsx)(Text, { ...containerProps, ...otherTextProps, ...handlers, children: value });
};
DSTruncatedTooltipText.defaultProps = {
  value: "",
  zIndex: 110
};
const truncatedTooltipTextProps = {
  containerProps: import_ds_props_helpers.PropTypes.object.description("Set of Properties attached to the main container"),
  value: import_ds_props_helpers.PropTypes.oneOfType([import_ds_props_helpers.PropTypes.string, import_ds_props_helpers.PropTypes.number]).description(
    "Text that when truncated will trigger the tooltip interaction"
  ),
  tooltipPlacement: import_ds_props_helpers.PropTypes.oneOf([
    import_ds_popper.PopperPositions.AUTO_START,
    import_ds_popper.PopperPositions.AUTO_END,
    import_ds_popper.PopperPositions.AUTO,
    import_ds_popper.PopperPositions.TOP_START,
    import_ds_popper.PopperPositions.TOP,
    import_ds_popper.PopperPositions.TOP_END,
    import_ds_popper.PopperPositions.RIGHT_START,
    import_ds_popper.PopperPositions.RIGHT,
    import_ds_popper.PopperPositions.RIGHT_END,
    import_ds_popper.PopperPositions.BOTTOM_START,
    import_ds_popper.PopperPositions.BOTTOM,
    import_ds_popper.PopperPositions.BOTTOM_END,
    import_ds_popper.PopperPositions.LEFT_START,
    import_ds_popper.PopperPositions.LEFT,
    import_ds_popper.PopperPositions.LEFT_END
  ]).description("Position of the tooltip"),
  tooltipDelay: import_ds_props_helpers.PropTypes.number.description("Delay to show the tooltip"),
  zIndex: import_ds_props_helpers.PropTypes.number.description("override default zIndex").defaultValue(110)
};
DSTruncatedTooltipText.defaultProps = {
  containerProps: {},
  value: "",
  tooltipPlacement: void 0,
  tooltipDelay: void 0
};
DSTruncatedTooltipText.displayName = "DSTruncatedTooltipText";
const TruncatedTooltipTextWithSchema = (0, import_ds_props_helpers.describe)(DSTruncatedTooltipText);
TruncatedTooltipTextWithSchema.propTypes = truncatedTooltipTextProps;
var DSTruncatedTooltipText_default = DSTruncatedTooltipText;
//# sourceMappingURL=DSTruncatedTooltipText.js.map
