"use strict";
var __create = Object.create;
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __getProtoOf = Object.getPrototypeOf;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toESM = (mod, isNodeMode, target) => (target = mod != null ? __create(__getProtoOf(mod)) : {}, __copyProps(
  // If the importer is in node compatibility mode or this is not an ESM
  // file that has been converted to a CommonJS file using a Babel-
  // compatible transform (i.e. "__esModule" has not been set), then set
  // "default" to the CommonJS "module.exports" for node compatibility.
  isNodeMode || !mod || !mod.__esModule ? __defProp(target, "default", { value: mod, enumerable: true }) : target,
  mod
));
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);
var SimpleTruncatedTooltipText_exports = {};
__export(SimpleTruncatedTooltipText_exports, {
  SimpleTruncatedTooltipText: () => SimpleTruncatedTooltipText,
  default: () => SimpleTruncatedTooltipText_default
});
module.exports = __toCommonJS(SimpleTruncatedTooltipText_exports);
var React = __toESM(require("react"));
var import_jsx_runtime = require("react/jsx-runtime");
var import_react = require("react");
var import_prop_types = __toESM(require("prop-types"));
var import_ds_system = require("@elliemae/ds-system");
var import_ds_popover = require("@elliemae/ds-popover");
var import_useCancellableDelayedCallback = require("./useCancellableDelayedCallback.js");
const dsTestId = "DS-SimpleTruncateText";
const isEllipsisActive = ({ offsetWidth, scrollWidth }) => offsetWidth < scrollWidth;
const initialTooltipState = (value = "", options = {}) => ({
  reference: null,
  visible: false,
  value,
  options
});
const Text = import_ds_system.styled.span`
  text-overflow: ellipsis;
  white-space: nowrap;
  overflow: hidden;
  display: inline-block;
  max-width: 100%;
`;
const SimpleTruncatedTooltipText = (props) => {
  const { containerProps, tooltipDelay, placement, value, zIndex, tooltipOptions, textOptions } = props;
  const [tooltipState, setTooltipState] = (0, import_react.useState)(initialTooltipState(value, tooltipOptions));
  const show = (0, import_react.useCallback)(
    (newState) => {
      setTooltipState({ ...tooltipState, ...newState, visible: true });
    },
    [tooltipState]
  );
  const hideTooltip = (0, import_react.useCallback)(
    (newState) => {
      setTooltipState({ ...tooltipState, ...newState, visible: false });
    },
    [tooltipState]
  );
  const [showTooltip, cancelShowTooltip] = (0, import_useCancellableDelayedCallback.useCancellableDelayedCallback)(show, tooltipDelay);
  const handleMouseEnter = (0, import_react.useCallback)(
    (e) => {
      const { target } = e;
      const SimpleTruncatedTextEl = target.closest(`[data-testid="${dsTestId}"]`);
      if (SimpleTruncatedTextEl && isEllipsisActive(SimpleTruncatedTextEl)) {
        showTooltip({ value, reference: SimpleTruncatedTextEl });
      }
    },
    [showTooltip, value]
  );
  const handleMouseLeave = (0, import_react.useCallback)(() => {
    cancelShowTooltip();
    hideTooltip({ reference: null });
  }, [hideTooltip, cancelShowTooltip]);
  const handlers = (0, import_react.useMemo)(() => {
    if (!showTooltip) return {};
    return {
      onMouseEnter: handleMouseEnter,
      onMouseLeave: handleMouseLeave
    };
  }, [showTooltip, handleMouseEnter, handleMouseLeave]);
  const theme = (0, import_react.useContext)(import_ds_system.ThemeContext);
  const PurePopover = (0, import_react.useMemo)(
    () => /* @__PURE__ */ (0, import_jsx_runtime.jsx)(import_jsx_runtime.Fragment, { children: tooltipState.visible ? /* @__PURE__ */ (0, import_jsx_runtime.jsx)(
      import_ds_popover.DSPopover,
      {
        boundaries: "window",
        style: { pointerEvents: "none", zIndex: zIndex ?? theme.zIndex.tooltip },
        placement,
        content: tooltipState.value,
        referenceEl: tooltipState.reference,
        visible: tooltipState.visible,
        showArrow: true
      }
    ) : null }),
    [tooltipState, placement, zIndex]
  );
  const PureText = (0, import_react.useMemo)(
    () => /* @__PURE__ */ (0, import_jsx_runtime.jsx)(import_jsx_runtime.Fragment, { children: /* @__PURE__ */ (0, import_jsx_runtime.jsx)(
      Text,
      {
        ...containerProps && { ...containerProps },
        ...textOptions && { ...textOptions },
        ...handlers && { ...handlers },
        "data-testid": dsTestId,
        children: value
      }
    ) }),
    [containerProps, textOptions, handlers, value]
  );
  const PureSimpleTruncatedTooltipText = (0, import_react.useMemo)(
    () => /* @__PURE__ */ (0, import_jsx_runtime.jsxs)(import_jsx_runtime.Fragment, { children: [
      PureText,
      PurePopover
    ] }),
    [PureText, PurePopover]
  );
  return PureSimpleTruncatedTooltipText;
};
SimpleTruncatedTooltipText.propTypes = {
  containerProps: import_prop_types.default.object,
  tooltipOptions: import_prop_types.default.object,
  textOptions: import_prop_types.default.object,
  /** Text that when truncated will trigger the tooltip interaction */
  value: import_prop_types.default.oneOfType([import_prop_types.default.string, import_prop_types.default.number, import_prop_types.default.node]),
  /** Position of the tooltip */
  placement: import_prop_types.default.oneOf([
    import_ds_popover.PopperPositions.AUTO_START,
    import_ds_popover.PopperPositions.AUTO_END,
    import_ds_popover.PopperPositions.AUTO,
    import_ds_popover.PopperPositions.TOP_START,
    import_ds_popover.PopperPositions.TOP,
    import_ds_popover.PopperPositions.TOP_END,
    import_ds_popover.PopperPositions.RIGHT_START,
    import_ds_popover.PopperPositions.RIGHT,
    import_ds_popover.PopperPositions.RIGHT_END,
    import_ds_popover.PopperPositions.BOTTOM_START,
    import_ds_popover.PopperPositions.BOTTOM,
    import_ds_popover.PopperPositions.BOTTOM_END,
    import_ds_popover.PopperPositions.LEFT_START,
    import_ds_popover.PopperPositions.LEFT,
    import_ds_popover.PopperPositions.LEFT_END
  ]),
  /** Delay to show the tooltip */
  tooltipDelay: import_prop_types.default.number,
  /** override default zIndex */
  zIndex: import_prop_types.default.number
};
SimpleTruncatedTooltipText.defaultProps = {
  containerProps: {},
  tooltipOptions: {},
  textOptions: {},
  value: "",
  placement: import_ds_popover.PopperPositions.TOP,
  tooltipDelay: 200
};
var SimpleTruncatedTooltipText_default = SimpleTruncatedTooltipText;
//# sourceMappingURL=SimpleTruncatedTooltipText.js.map
