import * as React from "react";
import { jsx, jsxs } from "react/jsx-runtime";
import React2, { useMemo, useState } from "react";
import { DSPopover, usePopoverProviderState } from "@elliemae/ds-popover";
const TruncatedTooltipContext = React2.createContext();
const { Provider } = TruncatedTooltipContext;
const TooltipTextProvider = ({ children, tooltipDelay = 200, placement = "top", ...tooltipOptions }) => {
  const {
    show: showTooltip,
    hide: hideTooltip,
    state: tooltipState
  } = usePopoverProviderState({ delay: tooltipDelay });
  const [zIndex, setZIndex] = useState(110);
  const value = useMemo(
    () => ({
      showTooltip,
      hideTooltip,
      setZIndex
    }),
    []
  );
  return /* @__PURE__ */ jsxs(Provider, { value, children: [
    children,
    tooltipState.visible ? /* @__PURE__ */ jsx(
      DSPopover,
      {
        boundaries: "window",
        placement,
        showArrow: true,
        ...tooltipOptions,
        ...tooltipState.options || {},
        content: tooltipState.value,
        referenceEl: tooltipState.reference,
        style: { pointerEvents: "none", zIndex },
        visible: tooltipState.visible
      }
    ) : null
  ] });
};
TooltipTextProvider.propTypes = {};
TooltipTextProvider.defaultProps = {};
var TooltipTextProvider_default = TooltipTextProvider;
export {
  TooltipTextProvider,
  TruncatedTooltipContext,
  TooltipTextProvider_default as default
};
//# sourceMappingURL=TooltipTextProvider.js.map
