/// <reference types="react" />
import PropTypes from 'prop-types';
interface SimpleTruncatedTooltipTextProps {
    containerProps?: Record<string, unknown>;
    tooltipDelay?: number;
    placement?: string;
    value?: string | JSX.Element;
    zIndex?: number;
    tooltipOptions?: Record<string, unknown>;
    textOptions?: Record<string, unknown>;
}
declare const SimpleTruncatedTooltipText: {
    (props: SimpleTruncatedTooltipTextProps): import("react/jsx-runtime.js").JSX.Element;
    propTypes: {
        containerProps: PropTypes.Requireable<object>;
        tooltipOptions: PropTypes.Requireable<object>;
        textOptions: PropTypes.Requireable<object>;
        /** Text that when truncated will trigger the tooltip interaction */
        value: PropTypes.Requireable<NonNullable<PropTypes.ReactNodeLike>>;
        /** Position of the tooltip */
        placement: PropTypes.Requireable<string>;
        /** Delay to show the tooltip */
        tooltipDelay: PropTypes.Requireable<number>;
        /** override default zIndex */
        zIndex: PropTypes.Requireable<number>;
    };
    defaultProps: {
        containerProps: {};
        tooltipOptions: {};
        textOptions: {};
        value: string;
        placement: string;
        tooltipDelay: number;
    };
};
export { SimpleTruncatedTooltipText };
export type { SimpleTruncatedTooltipTextProps };
export default SimpleTruncatedTooltipText;
